/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {

	mui.init({
		statusBarBackground: '#f7f7f7'
	});

	var toMain = function() {
		console.log("toMain");
		var mainPage = plus.webview.getWebviewById('../attendance/attendance.html');
		console.log(mainPage.id);
		//绑定个人资料
		mui.fire(mainPage, 'loginsetPersonInfo', {});


		setTimeout(function() {
			document.getElementById('username').value = "";
			document.getElementById('password').value = ""; //设置为空以免退出登录进来的时候有值
		}, 2000);
		//			setTimeout(function() {
		//				$.openWindow({
		//					id: '../attendance/attendance.html',
		//					show: {
		//						aniShow: 'none'
		//					},
		//					waiting: {
		//						autoShow: false
		//					}
		//				});
		//			}, 200);
	};
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, logincallback) {
		logincallback = logincallback || $.noop;
		loginInfo = loginInfo || {};

		loginInfo.username = loginInfo.username || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.username.length == 0) {
			return logincallback('账号不能为空');
		}
		if (loginInfo.password.length == 0) {
			return logincallback('密码不能为空');
		}

		var result = {};

		result.username = loginInfo.username;
		result.token = "";
		result.refreshToken = "";
		result.password = "";

		var params = {
			grant_type: "password",
			scope: "allhr",
			client_id: "trustoodApp",
			client_secret: "trustoodApp",
			userName: loginInfo.username,
			Password: loginInfo.password
		};

		plus.nativeUI.showWaiting("登录中...");
		var form = document.getElementById(loginInfo.formId);
		common.PostData(common.baseUrl + common.ServerApiUrls.TokenUrl, params, 'application/x-www-form-urlencoded', 'json', function(result) {

			result.username = loginInfo.username;
			result.password = loginInfo.password;
			common.createLoginState(result, function() {

				//获取账号信息
				params = {
					EmailOrPhone: loginInfo.username
				};
				common.getData(common.baseUrl + common.ServerApiUrls.GetUserInfo, params, function(result) {
					var status = common.getState();
					if (result != null && result.userInfoData != null) {
						if (result.userInfoData.avatars == null || result.userInfoData.avatars == "" || result.userInfoData.avatars == "null")
							result.userInfoData.avatars = "../../images/me_data_default_image.png"; //默认头像
					}
					status.UserData = result.userInfoData;
					common.setState(status);


					//获取员工信息
					params = {
						UserId: status.UserData.id
					};
					common.getData(common.baseUrl + common.ServerApiUrls.GetEmpInfo, params, function(result) {
						var status = common.getState();
						if (result != null && result.getEmployee != null) {
							if (result.getEmployee.avatars == null || result.getEmployee.avatars == "" || result.getEmployee.avatars == "null")
								result.getEmployee.avatars = "../../me_data_default_image.png"; //默认头像
						}
						status.EmployeeData = result.getEmployee;
						common.setState(status);


						return logincallback();
					}, function(result) {
						plus.nativeUI.closeWaiting();
						return logincallback(result);
					});
				}, function(result) {
					plus.nativeUI.closeWaiting();
					return logincallback(result);
				});

			});

		}, function(result) {
			plus.nativeUI.closeWaiting();
			if (result.error) {
				switch (result.error) {
					case 'invalid_grant':
						switch (result.error_description) {
							case '1':
								logincallback('用户名或密码为空');
								break;
							case '2':
								logincallback('用户名或密码错误');
								break;
							default:
								logincallback('系统错误,请稍候再试');
						}
						break;
					default:
						logincallback('非法操作');
				}
			} else
				logincallback(result);
		});
		form.onsubmit = function(e) {
			e.preventDefault();
		}

	};

	$.plusReady(function() {
		plus.push.setAutoNotification(false); //程序运行时设置消息中心不显示消息
		plus.screen.lockOrientation("portrait-primary");
		var settings = common.getSettings();
		var state = common.getLoginState();
		var stylesv = {
			popGesture: "none"
		}; //关闭ios右滑关闭窗体
		if (!plus.webview.defauleHardwareAccelerated() && parseInt(plus.os.version) >= 5) {
			stylesv.hardwareAccelerated = true;
		} else
			stylesv.hardwareAccelerated = false;
		var mainPage = $.preload({
			"id": '../attendance/attendance.html',
			"url": 'app/attendance/attendance.html',
			"styles": stylesv
		});
		var unlock = $.preload({
			"id": 'unlock',
			"url": 'unlock.html',
			"styles": stylesv
		});
		console.log(plus.webview.currentWebview().id);
		mainPage.addEventListener('loaded', function() {
			console.log('loaded');
			//检查 "登录状态/锁屏状态" 开始
			console.log(settings.isgestures);
			console.log(settings.gestures);
			console.log(state.token);
			if (state.token && (settings.isgestures=="1") && settings.gestures) { //settings.autoLogin && 自动登录功能改成必须
				console.log(unlock);
				setTimeout(function() {
					//关闭 splash
					plus.navigator.closeSplashscreen();
				}, 1500);
				$.openWindow({
					id: 'unlock',
					show: {
						aniShow: 'none'
					},
					waiting: {
						autoShow: false
					}
				});
			} else if (state.token) {
				// close splash
				setTimeout(function() {
					//关闭 splash
					plus.navigator.closeSplashscreen();
				}, 1500);
				toMain();
			} else
			// close splash
				setTimeout(function() {
				//关闭 splash
				plus.navigator.closeSplashscreen();
			}, 1500);
			//检查 "登录状态/锁屏状态" 结束
			var loginButton = document.getElementById('login');
			var accountBox = document.getElementById('username');
			var passwordBox = document.getElementById('password');
			var autoLoginButton = true;

			loginButton.addEventListener('tap', function(event) {
				console.log('loginButton');
				var loginInfo = {
					username: accountBox.value,
					password: passwordBox.value,
					formId: "login-form"
				};
				owner.login(loginInfo, function(err) {
					if (err) {
						plus.nativeUI.toast(err);
						return;
					}
					toMain();
				});
			});
			$.enterfocus('#login-form input', function() {
				$.trigger(loginButton, 'tap');
			});
			//后退
			var backButtonPress = 0;
			$.back = function(event) {
				backButtonPress++;
				if (backButtonPress > 1) {
					plus.runtime.quit();
				} else {
					plus.nativeUI.toast('再按一次退出应用');
				}
				setTimeout(function() {
					backButtonPress = 0;
				}, 1000);
				return false;
			};
		});
	});

}(mui, window.app = {}));