(function($, owner) {

	owner.getData = function(url, data, callback, failure) {
		var oXhr = new plus.net.XMLHttpRequest();
		oXhr.onreadystatechange = function() {
			if (oXhr.readyState == 4) {
				if (oXhr.status == 200) {
					try {
						var result = JSON.parse(oXhr.responseText);
					} catch (e) {
						if (failure) failure(e);
					}
					if (callback) callback(result);
				} else {
					if (oXhr.status == 401) { //未授权,退出登录

					} else if (failure) failure("系统错误,请联系管理员");
				}
			}
		};

		if (data != null) {
			url += "?";
			for (var x in data) {
				url += x + "=" + data[x] + "&";
			}
			url = url.substr(0, url.length - 1);
		}
		console.log(url);
		oXhr.open("GET", url);
		var status = common.getLoginState();
		oXhr.setRequestHeader('Authorization', 'Bearer ' + (typeof(status) != "undefined" ? status.token : ''));
		oXhr.send();
	}

	owner.PostData = function(url, data, contenttype, responsetype, callback, failure) {
		var oXhr = new plus.net.XMLHttpRequest();
		oXhr.onreadystatechange = function() {

			if (oXhr.readyState == 1) {
				if (contenttype != null)
					oXhr.setRequestHeader('Content-Type', contenttype);
				else
					oXhr.setRequestHeader('Content-Type', "application/json"); //默认json提交
			}

			if (oXhr.readyState == 4) {
				if (oXhr.status == 200) {
					try {
						var strResult = oXhr.responseText;
						if (callback) {
							var result = strResult;
							if (responsetype == 'json' || responsetype == null) {
								result = JSON.parse(strResult);
							}
							callback(result);
						}
					} catch (e) {
						if (failure) failure(e);
					}
				} else {
					if (oXhr.status == 401) { //未授权,退出登录

					} else if (failure) {
						if (oXhr.status == 400) {
							var result = JSON.parse(oXhr.responseText);
							failure(result);
						} else
							failure("系统错误,请联系管理员");
					}
				}
			}
		};



		var status = common.getLoginState();
		oXhr.open("POST", url);
		oXhr.setRequestHeader('Authorization', 'Bearer ' + (typeof(status) != "undefined" ? status.token : ''));
		if (data) {
			if (contenttype == "application/x-www-form-urlencoded") {
				var dataStr = "";
				if (data != null) {
					for (var x in data) {
						dataStr += x + "=" + data[x] + "&";
					}
					dataStr = dataStr.substr(0, dataStr.length - 1);
				}
				oXhr.send(dataStr);
			} else
				oXhr.send(data);
		} else
			oXhr.send();
	}


	owner.formToString = function(formObj) {
		var allStr = "";
		if (formObj) {
			var elementsObj = formObj.elements;
			var obj;
			if (elementsObj) {
				for (var i = 0; i < elementsObj.length; i += 1) {
					obj = elementsObj[i];
					if (obj.name != undefined && obj.name != "") {
						if (allStr == "") {
							allStr += obj.name + "=" + encodeURIComponent(obj.value);
						} else {
							allStr += "&" + obj.name + "=" + encodeURIComponent(obj.value);
						}
					}
				}
			} else {
				mui.alert("没有elements对象!");
				return;
			}
		} else {
			return;
		}
		return allStr;
	}

	//是否选择公司
	owner.isSetCompany = function() {
		var setting = getSettings();
		if (setting != undefined && setting.companyUrl != undefined && setting.companyUrl != '')
			return true;
		else
			return false;
	}


	owner.createLoginState = function(obj, callback) {
		var state = owner.getLoginState();
		state.username = obj.username;
		state.token = obj.access_token;
		state.expires = obj.expires_in;
		state.tokenType = obj.token_type;
		state.password = obj.password
		owner.setLoginState(state);
		return callback();
	};


	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	owner.getLoginState = function() {
		var stateText = localStorage.getItem('$loginstate') || "{}";
		return JSON.parse(stateText);
	};

	owner.setLoginState = function(loginstate) {
		loginstate = loginstate || {};
		localStorage.setItem('$loginstate', JSON.stringify(loginstate));
	};

	owner.clearState = function() {
		localStorage.clear();
	}


	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if (!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}

	//获取角标数据
	owner.getBadge = function() {
		var setting = owner.getSettings();
		var state = owner.getState();
		var badgeText = localStorage.getItem('$' + setting.companyUrl + '&' + state.username) || "[]";
		return JSON.parse(badgeText);
	}


	//存储角标数据
	owner.saveBadge = function(badge) {
		badge = badge || [];
		var setting = owner.getSettings();
		var state = owner.getState();
		var badgeText = localStorage.setItem('$' + setting.companyUrl + '&' + state.username, JSON.stringify(badge));
	}

	owner.baseUrl = 'http://api.allhr.cn';
	//api的接口地址定义
	owner.ServerApiUrls = {
		"TokenUrl": "/connect/token", //登陆地址
		"CompanyLiUrl": "http://ds.allhr.cn/company.json", //获取公司列表地址
		"GetEmployee": "api/Employee/GetToken", //获取通讯录个人信息
		"Update": "http://ds.allhr.cn/update.json", //检查更新
		"GetApplyDetail": "http://ds.allhr.cn/GetApplyDetail.json", //获取单据信息
		"GetapplyMessages": "http://ds.allhr.cn/GetapplyMessages.json", //获取单据申请消息
		"GetMyApplyMessages": "http://ds.allhr.cn/GetMyApplyMessages.json", //获取我的单据消息
		"GetEmpInfo": "/GetEmployee", //获取员工信息
		"GetUserInfo": "/GetUserInfo", //获取账号信息
		"PunchCard": "api/Employee/PunchCard", //打卡
		"GetCompanyInfo": "/GetCompanyInfo", //获取公司信息
		"GetContract": "/GetContractEmployees", //获取通讯录
		"ChangePsw": "/UpdatePwd", //更改密码
	};

	//设置所有页面的角标
	owner.setAllViewBadge = function(badges) {
		var arr = mui("a.mui-navigate-right");
		for (var i = 0; i < arr.length; i++) {
			var hrf = arr[i].getAttribute('href');
			if (hrf != "" && hrf != undefined && hrf != null) {
				var view = plus.webview.getWebviewById(hrf);
				if (view != "" && view != undefined && view != null && view.isVisible()) {
					mui.fire(view, 'setHtmlBadgesOut', {
						obj: badges
					});
				}
			}
		}
	}

}(mui, window.common = {}));